<?php
/**
* @version 1.1
* @package DB Admin
* @copyright (C) 2006 David Thomas
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/
 
/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or
    die( 'Direct Access to this location is not allowed.' );
 
/**
 * @package DB Admin
 */
class HTML_DB_ADMIN {
  /**
     * DB_ADMIN CLASS
     * First version, only used to set a new table prefix in the DB.
     */
	function showMainForm(){
	global $mosConfig_dbprefix, $mosConfig_absolute_path;
		$config_file = $mosConfig_absolute_path . '/configuration.php';
		mosCommonHTML::loadOverlib();
		?>
		<script type="text/javascript">
		function validate(form){
			var current_prefix = '<?=$mosConfig_dbprefix;?>';
			if(form.cp.value != current_prefix){ //generic prefix specified
				if(form.uc.checked){
					var confirmed = confirm('You have chosen to specify a new current table prefix different from that of the current Joomla installation.\nTherefore, The current Joomla configuration file will not be updated to this prefix.\nOnly the database tables prefixes will be renamed ( '+form.cp.value+ ' to '+form.np.value +' ).');
					if(confirmed){
						form.uc.value='no'; //don't update config file
					}
					else{
						return false;
					}
				}
			}else if((form.cp.value == current_prefix) && (!form.cp.disabled) && (form.uc.disabled) ){ // search prefix is current prefix	
					alert('Please select config file options.');
					form.uc.disabled=false; //update config file
					form.uc.value='yes'; 
					form.uc.checked=true; 
					if(form.disable_write){
					form.disable_write.disabled=false; //enable config file update options
					}
					if(form.enable_write){
					form.enable_write.disabled=false;
					}
					return false;				
			}
			if(form.np.value==''){
				alert('Please enter a new table prefix');
				form.np.focus();
				return false;
			}
			if(form.cp.value==''){
				alert('Please enter a current table prefix');
				form.cp.focus();
				return false;
			}
			var l = form.np.value.length;
			var c = form.np.value.charAt(l-1);
			if(c != '_'){ //check underscore character exists
				var confirmed = confirm('The new prefix you entered does not contain an underscore character at the end.\nDo you want to add an underscore character? i.e: '+form.np.value+ ' to '+form.np.value+'_' );
				if(confirmed){
				form.np.value = form.np.value + '_';
				return true
				}
				return true;
			}
			return true;
		}
		function confirmGenericPrefix(form){
			var current_prefix = '<?=$mosConfig_dbprefix;?>';
			var confirmed = confirm('Do you want to change the current prefix to a generic prefix?\nThe default prefix ( '+current_prefix+' ) is this current Joomla installation\'s table prefix.\nChanging this value will allow you to do a search and replace on any table prefix in the current database, not just that of your current Joomla installation.');
			if(confirmed){
				form.cp.disabled = false; //enable specification of generic prefix
				form.cp.focus();
				form.cp.select();
				form.uc.checked = false; //disable config file update for generic prefix update
				form.uc.disabled = true;
				form.disable_write.disabled=true;
				form.enable_write.disabled=true;
			}else{
				form.cp.value = current_prefix; //assign default current prefix
				form.cp.disabled=true;
				form.uc.checked = true; //enable config file update
				form.uc.disabled = false;
				form.disable_write.disabled=false; //enable config file update options
				form.enable_write.disabled=false;
				form.np.focus();
				form.np.select();
			}
		}
		function configCheck(form){
			if(form.uc.checked){
				form.disable_write.disabled=false; //enable read/write options
				form.enable_write.disabled=false;
			}else{
				form.disable_write.disabled=true; //disable config update options
				form.enable_write.disabled=true;
			}
		}
		</script>
		<table width="25%"><tr><td>
		<h1>DB Admin</h1><br />
		<?
		$tabs = new mosTabs( 1 );
		$tabs->startPane( "db_admin" );
		$tabs->startTab("Table Prefix","tab-main");
		?>
		<table class="adminform">
		<th>Set Table Prefix</th>
		<tr>
		<td>
			<b><span onmouseover="return overlib('This script will change your database table prefix by performing a search and replace on every table in your joomla installation database. e.g. jos_content -> abc_content. If the search prefix is not found in a table name, the original table name will be preserved.', CAPTION, 'Set Table Prefix', BELOW, RIGHT);" onmouseout="return nd();">Set Table Prefix</span></b>
			<form action="index2.php" method="post" id="adminForm" name="adminForm" enctype="" onsubmit="return validate(this);"><br />
			<? $message=mosGetParam($_REQUEST,"message",'');if($message){ print $message; } ?>
			<input type='text' disabled="true" name='cp' value='<?=$mosConfig_dbprefix;?>'><span onmouseover="return overlib('Current DB table prefix (default) or prefix to search for (advanced)', CAPTION, 'Current or Search Prefix', BELOW, RIGHT);" onmouseout="return nd();">&nbsp;&nbsp;Search Prefix</span>&nbsp;&nbsp;<input class="button" name="edit" value="edit" type="button" title="specify new search prefix" onclick="confirmGenericPrefix(document.forms['adminForm']);"><br />
			<input type='text' name='np' value=''><span onmouseover="return overlib('New database table prefix e.g jos_', CAPTION, 'New Table Prefix', BELOW, RIGHT);" onmouseout="return nd();">&nbsp;&nbsp;Replace Prefix</span><br />
			<br />
			<input class="button" name="submit" value="Update Table Prefixes" type="submit"><br />
			<input type="checkbox" name="uc" value="yes" checked onclick="configCheck(document.forms['adminForm'])"><span onmouseover="return overlib('If updating current Joomla prefix, update $mosConfig_dbprefix to new value in configuration.php (recommended)', CAPTION, 'Update System Config File', BELOW, RIGHT);" onmouseout="return nd();">Update configuration file.</span><br />
			<?
			if (mosIsChmodable($config_file)) {
				if (is_writable($config_file)) {
				?>
					<input type="checkbox" id="disable_write" name="disable_write" value="1"/>
					<label for="disable_write">Make read-only after saving</label>
				<?
				} else {
				?>  <!-- override write protection, if present -->
					<input type="hidden" id="enable_write" name="enable_write" value="1"/>
				<?
				} // if
			} // if
			?>
			<input type="hidden" name="option" value="com_dbadmin">
			<input type="hidden" name="task" value="setPrefix">
			</form>
			<br />		
		</td>
		</tr>
		</table>	
		<?
        $tabs->endTab();
		$tabs->endPane();
		?></td></tr></table>
		<script>document.forms['adminForm'].elements['np'].focus();</script>
		<?	
	}
}
?>